unit uLogin;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  System.IOUtils, FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Objects, FMX.Edit,
  {Database}SQLiteUniProvider, MySQLUniProvider, UniProvider, DBAccess, Data.DB,
  MemDS, Uni{Database}, {$IFDEF MSWINDOWS} Winapi.Windows, System.Win.Registry,{$ENDIF}
  FMX.Effects;

type
  TfLogin = class(TForm)
    imgComp: TImage;
    grbConnect: TGroupBox;
    lblComp: TLabel;
    Label2: TLabel;
    edtDatabase: TEdit;
    btnDatabase: TDropDownEditButton;
    ShadowEffect1: TShadowEffect;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtDatabaseClick(Sender: TObject);
    procedure edtDatabaseKeyUp(Sender: TObject; var Key: Word;
      var KeyChar: Char; Shift: TShiftState);
    procedure btnDatabaseClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
  private
    procedure InfoConn;
    procedure LoadcmbDatabase;
  public
    qryInfoDatabase, qryInfoServer, qryFullName: TUniQuery;
    ServerNo: integer;
  end;

var
  fLogin: TfLogin;


implementation

{$R *.fmx}

uses uWarehouseInTransit, umyComboBox;

var
  pvdInfo: TSQLiteUniProvider;
  pvdLogin: TMySQLUniProvider;
  qryLogin, qryWaktu: TUniQuery;
  loginsuccess: boolean;

procedure CurrentWinResolution;
{$IFDEF MSWINDOWS}
var
  RegistryEntry: TRegistry;
{$ENDIF}
begin
  try
    {$IFDEF MSWINDOWS}
    RegistryEntry:= TRegistry.Create(KEY_READ);
    RegistryEntry.RootKey:= HKEY_CURRENT_USER;
    RegistryEntry.OpenKey('Control Panel\Desktop\WindowMetrics\', False);
    if RegistryEntry.ReadInteger('AppliedDPI')= 96 then begin
      WinDPI:= 0/100;
    end else if RegistryEntry.ReadInteger('AppliedDPI')= 120 then begin
      WinDPI:= 25/100;
    end else if RegistryEntry.ReadInteger('AppliedDPI')= 144 then begin
      WinDPI:= 50/100;
    end else if RegistryEntry.ReadInteger('AppliedDPI')= 168 then begin
      WinDPI:= 75/100;
    end else if RegistryEntry.ReadInteger('AppliedDPI')= 192 then begin
      WinDPI:= 100/100;
    end;
    {$ENDIF}
  finally
    {$IFDEF MSWINDOWS}
    FreeAndNil(RegistryEntry);
    {$ENDIF}
  end;
end;


procedure TfLogin.LoadcmbDatabase;
begin
  edtDatabase.SetFocus;
  myForm:= '';
  myForm:= 'fLogin.edtDatabase';
  fmyComboBox:= TfmyComboBox.Create(self);
  {$IFDEF MSWINDOWS}
  fmyComboBox.Left:= Left+ Round(grbConnect.Position.X+
    (grbConnect.Position.X* WinDPI)+ edtDatabase.Position.X+
    (edtDatabase.Position.X* WinDPI)+ 7.5+ (7.5* WinDPI));
  fmyComboBox.Top:= Top+ Round(grbConnect.Position.Y+
    (grbConnect.Position.Y* WinDPI)+ edtDatabase.Position.Y+
    (edtDatabase.Position.Y*WinDPI)+ 30.5+ (30.5* WinDPI));
  {$ENDIF}
  {$IFDEF LINUX64}
  fmyComboBox.Left:= Left+ Round(grbConnect.Position.X+ edtDatabase.Position.X);
  fmyComboBox.Top:= Top+ Round(grbConnect.Position.Y+ edtDatabase.Position.Y);
  {$ENDIF}
  fmyComboBox.edtSearch.Text:= edtDatabase.Text.Trim;
  fmyComboBox.edtSearch.Width:= edtDatabase.Width- btnDatabase.Width- 4;
  fmyComboBox.Visible:= True;
  fmyComboBox.Show;
end;

procedure TfLogin.InfoConn;
var
  myintransit, myroot: string;
begin
  {$IFDEF MSWINDOWS}
  myroot:= '\';
  {$ENDIF}
  {$IFDEF LINUX64}
  myroot:= '/';
  {$ENDIF}
  myintransit:= System.IOUtils.TPath.GetDocumentsPath +myroot+ 'myintransit';
  try
    if FileExists(myintransit)= True then begin
      with conInfo do begin
        ProviderName:= pvdInfo.GetProviderName;
        Database:= myintransit;
        SpecificOptions.Values['Direct']:= 'True';
        Connected:= True;
      end;
    end else begin
      with conInfo do begin
        ProviderName:= pvdInfo.GetProviderName;
        Database:= myintransit;
        SpecificOptions.Values['Direct']:= 'True';
        SpecificOptions.Values['ForceCreateDatabase']:= 'True';
        Connected:= True;
        ExecSQL('PRAGMA foreign_keys = OFF');
        ExecSQL('DROP TABLE IF EXISTS data_detail');
        ExecSQL('DROP TABLE IF EXISTS data_master');
        ExecSQL('DROP TABLE IF EXISTS usrlogin');
        ExecSQL('CREATE TABLE usrlogin ( superior integer NOT NULL, '+
          'usernames character varying(255) NOT NULL, '+
          'passwords character varying(255) NOT NULL, '+
          'CONSTRAINT usernames_pkey PRIMARY KEY (usernames) ON CONFLICT ROLLBACK '+
          ') WITHOUT ROWID');
        ExecSQL('INSERT OR IGNORE INTO usrlogin VALUES ( 0, ''E/mFbW5O9NvqANJc/zpOkA=='', '+
          '''WRDTNinhktMDdvn8SHs0YQBvsjYT+HKhhcAOuQwHdK8='' )');
        ExecSQL('CREATE TABLE data_master ( '+
          'dbname character varying(20) NOT NULL, active integer DEFAULT 0, '+
          'myport integer NOT NULL, company character varying(50) NOT NULL, '+
          'logo22 BLOB, logo75 BLOB, icon BLOB, '+
          'CONSTRAINT dbname_pkey PRIMARY KEY (dbname) ON CONFLICT ROLLBACK '+
          ') WITHOUT ROWID');
        ExecSQL('CREATE TABLE data_detail ( '+
          'serverkey character varying(255) NOT NULL, '+
          'servername character varying(255) NOT NULL, '+
          'active integer DEFAULT 0, dbname character varying(20) NOT NULL, '+
          'serverip character varying(20) NOT NULL ON CONFLICT ROLLBACK, '+
          'servernumber integer NOT NULL, '+
          'CONSTRAINT serverkey_pkey PRIMARY KEY (serverkey) ON CONFLICT ROLLBACK, '+
          'CONSTRAINT dbname_fkey FOREIGN KEY (dbname) REFERENCES data_master (dbname) '+
          'ON DELETE RESTRICT ON UPDATE CASCADE '+
          ') WITHOUT ROWID');
        ExecSQL('PRAGMA foreign_keys = ON');
        ExecSQL('VACUUM');
      end;
    end;
  finally
  end;
end;

procedure TfLogin.btnDatabaseClick(Sender: TObject);
begin
  LoadcmbDatabase;
end;

procedure TfLogin.edtDatabaseClick(Sender: TObject);
begin
  LoadcmbDatabase;
end;

procedure TfLogin.edtDatabaseKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (Key= 13) or (Key= 38) or (Key= 40) then begin
    LoadcmbDatabase;
  end;
end;

procedure TfLogin.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= TCloseAction.caFree;
end;

procedure TfLogin.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if loginsuccess= False then fWarehouseInTransit.JumpFormCreate:= True;
end;

procedure TfLogin.FormCreate(Sender: TObject);
begin
  loginsuccess:= False;
  Position:= TFormPosition.MainFormCenter;
  lblComp.Text:= '';
  edtDatabase.ReadOnly:= True;
  superior:= False;
  pvdInfo:= TSQLiteUniProvider.Create(self);
  pvdLogin:= TMySQLUniProvider.Create(self);
  coninfo:= TUniConnection.Create(self);
  qryInfoDatabase:= TUniQuery.Create(self);
  qryInfoServer:= TUniQuery.Create(self);
  qryLogin:= TUniQuery.Create(self);
  qryWaktu:= TUniQuery.Create(self);
  qryFullName:= TUniQuery.Create(self);
  InfoConn;
  qryInfoDatabase.Connection:= conInfo;
  qryInfoServer.Connection:= conInfo;
  CurrentWinResolution;
end;

procedure TfLogin.FormDestroy(Sender: TObject);
begin
  FreeAndNil(qryInfoDatabase);
  FreeAndNil(qryInfoServer);
  FreeAndNil(qryLogin);
  FreeAndNil(qryWaktu);
  FreeAndNil(qryFullName);
  FreeAndNil(coninfo);
  FreeAndNil(pvdInfo);
  FreeAndNil(pvdLogin);
  fLogin:= nil;
  fWarehouseInTransit.Activate;
end;

procedure TfLogin.FormResize(Sender: TObject);
begin
  if Active= True then begin
    if ClientHeight<> 296 then ClientHeight:= 296;
    if ClientWidth<> 327 then ClientWidth:= 327;
  end;
end;

procedure TfLogin.FormShow(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}
  Left:= Left+ Round(Left* WinDPI);
  Top:= Top+ Round(Top* WinDPI);
  {$ENDIF}
end;

end.
