unit uWarehouseInTransit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.Ani, FMX.Layouts, System.ImageList, FMX.Controls.Presentation, FMX.ImgList,
  FMX.StdCtrls, {Database} DBAccess, Data.DB, MemDS, Uni{Database},
  FMX.TMSGraphicsTypes, FMX.TMSPageControl, FMX.TMSCustomControl, FMX.TMSTabSet,
  FMX.Effects;

type
  TfWarehouseInTransit = class(TForm)
    pclInTransit: TTMSFMXPageControl;
    tabTransactions: TTMSFMXPageControlContainer;
    tabReports: TTMSFMXPageControlContainer;
    fanPclInTransit: TFloatAnimation;
    pclForms: TTMSFMXPageControl;
    lytInTransit: TLayout;
    imgUsername: TImage;
    lytUsername: TLayout;
    Layout1: TLayout;
    btnLogout: TButton;
    Layout2: TLayout;
    imlInTransit: TImageList;
    lblUsername: TLabel;
    lytDateTime: TLayout;
    imgDate: TImage;
    lblDate: TLabel;
    lblTime: TLabel;
    lytDatabase: TLayout;
    imgDatabase: TImage;
    lblDatabase: TLabel;
    lytServername: TLayout;
    imgLocation: TImage;
    lblServername: TLabel;
    imgMessage: TImage;
    lblMessage: TLabel;
    btnCollapse: TButton;
    grbLogTrs: TGroupBox;
    grbOtrTrs: TGroupBox;
    btnIntIn: TButton;
    btnPayment: TButton;
    btnDo: TButton;
    btnSetting: TButton;
    GroupBox1: TGroupBox;
    btnGITRpt: TButton;
    btnPaymentRpt: TButton;
    btnDoRpt: TButton;
    btnGitOut: TButton;
    ShadowEffect1: TShadowEffect;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnPaymentClick(Sender: TObject);
    procedure btnCollapseClick(Sender: TObject);
    procedure btnLogoutClick(Sender: TObject);
    procedure imgUsernameDblClick(Sender: TObject);
    procedure btnDoClick(Sender: TObject);
    procedure pclInTransitClick(Sender: TObject);
  private
    procedure tmrServerTimer(Sender: TObject);
    procedure ButtonLogout;
  public
    JumpFormCreate: boolean;

  end;

var
  fWarehouseInTransit: TfWarehouseInTransit;
  conServer, conInfo: TUniConnection;
  srmIcon: TMemoryStream;
  windowset, myForm, DocNo, gusername, gdatabase, guserlocation, gserverLoc: string;
  authorized, superior: boolean;
  CTime: TTime;
  CDate: TDate;
  gtimeserver: TDateTime;
  mainformtop, mainformleft: integer;
  colorpoint0, colorpoint1: int64;
  WinDPI: single;

implementation

{$R *.fmx}

uses uLogin;

var
  tmrServer: TTimer;
  countmsg: integer;
  pclInTransitHeight: single;

procedure TfWarehouseInTransit.ButtonLogout;
begin
  pclForms.Pages.Clear;
  pclForms.Visible:= False;
  tmrServer.Enabled:= False;
  pclInTransit.Visible:= False;
  countmsg:= 0;
  lblUsername.Text:= '';
  lblDate.Text:= '';
  lblTime.Text:= '';
  lblDatabase.Text:= '';
  lblServername.Text:= '';
  lblMessage.Text:= '';
  lytUsername.Visible:= False;
  lytDateTime.Visible:= False;
  lytDatabase.Visible:= False;
  lytServername.Visible:= False;
  imgMessage.Visible:= False;
  if conServer.Connected= True then begin
    conServer.Connected:= False;
  end;
  JumpFormCreate:= False;
  Caption:= 'Warehouse InTransit';
  srmIcon.Position:= 0;
  btnLogout.Text:= 'Login';
  btnLogout.ImageIndex:= 7;
  fLogin:= TfLogin.Create(self);
  fLogin.ShowModal;
  if JumpFormCreate= False then begin
    //LoadBusiness;

    if windowset= 'normal' then begin
      WindowState:= TWindowState.wsNormal;
    end else if windowset= 'maximized' then begin
      WindowState:= TWindowState.wsMaximized;
    end;

    pclInTransit.Visible:= True;
    pclForms.Visible:= True;
    lytUsername.Visible:= True;
    lytDateTime.Visible:= True;
    lytDatabase.Visible:= True;
    lytServername.Visible:= True;
    lblUsername.Text:= gusername.Trim;
    lblDate.Text:= DateToStr(Date);
    lblTime.Text:= TimeToStr(Time);
    lblDatabase.Text:= Uppercase(gdatabase.Trim);
    tmrServer.Enabled:= True;
  end;
end;

procedure TfWarehouseInTransit.pclInTransitClick(Sender: TObject);
begin
  if pclInTransit.Height< pclInTransitHeight then begin
    pclInTransit.Height:= pclInTransitHeight;
    fanPclInTransit.StartValue:= btnCollapse.Height;
    fanPclInTransit.StopValue:= pclInTransitHeight;
    fanPclInTransit.Start;
    btnCollapse.ImageIndex:= 1;
    btnCollapse.Hint:= 'Collapse';
  end;
end;

procedure TfWarehouseInTransit.btnCollapseClick(Sender: TObject);
begin
  if pclInTransit.Height< pclInTransitHeight then begin
    pclInTransit.Height:= pclInTransitHeight;
    fanPclInTransit.StartValue:= btnCollapse.Height;
    fanPclInTransit.StopValue:= pclInTransitHeight;
    fanPclInTransit.Start;
    btnCollapse.ImageIndex:= 1;
    btnCollapse.Hint:= 'Collapse';
  end else if pclInTransit.Height= pclInTransitHeight then begin
    pclInTransit.Height:= btnCollapse.Height;
    fanPclInTransit.StartValue:= pclInTransitHeight;
    fanPclInTransit.StopValue:= btnCollapse.Height;
    fanPclInTransit.Start;
    btnCollapse.ImageIndex:= 2;
    btnCollapse.Hint:= 'Expand';
  end;
end;

procedure TfWarehouseInTransit.btnDoClick(Sender: TObject);
begin
  {if TCustTools.IsFormOpen('fDelivery')= True then begin
    pclForms.SelectTab((fDelivery.lytDelivery.GetParentComponent as
      TTMSFMXPageControlContainer).PageIndex);
  end else begin
    with pclForms do begin
      AddPage('DeliveryOrderList');
      SelectTab(Pages.Count- 1);
      with Pages.Tabs[Pages.Count- 1] do begin
        Bitmaps.AddBitmap(imgDatabase.Bitmap, 1);
        Text:= 'Delivery Order List';
        Hint:= Text;
      end;
      with PageContainers[Pages.Count- 1].Fill do begin
        Color:= colorpoint0;
        ColorTo:= colorpoint1;
        Kind:= TTMSFMXGraphicsFillKind.gfkGradient;
        Orientation:= TTMSFMXGraphicsFillOrientation.gfoHorizontal;
      end;
    end;
    fDelivery:= TfDelivery.Create(self);
    fDelivery.lytDelivery.Parent:= pclForms.PageContainers[pclForms.Pages.Count- 1];
  end; }
end;

procedure TfWarehouseInTransit.btnLogoutClick(Sender: TObject);
begin
  authorized:= False;
  if superior= False then begin
    //if ButtonClose= True then begin
      ButtonLogout;
    //end else begin
      {if TCustTools.IsFormOpen('fCshInput')= True then begin
        TCustTools.MsgBox('System can not logout because your Cashier are still '+
          'opened.', TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], TMsgDlgBtn.mbOK);
      end else begin
        ButtonLogout;
      end;
    end;}
  end else begin
    ButtonLogout;
  end;
end;

procedure TfWarehouseInTransit.btnPaymentClick(Sender: TObject);
begin
  {if TCustTools.IsFormOpen('fPayment')= True then begin
    pclForms.SelectTab((fPayment.lytPayment.GetParentComponent as
      TTMSFMXPageControlContainer).PageIndex);
  end else begin
    with pclForms do begin
      AddPage('Payment List');
      SelectTab(pclForms.Pages.Count- 1);
      Pages.Tabs[pclForms.Pages.Count- 1].Bitmaps.AddBitmap(imgDatabase.Bitmap, 1);
      with PageContainers[Pages.Count- 1].Fill do begin
        Color:= colorpoint0;
        ColorTo:= colorpoint1;
        Kind:= TTMSFMXGraphicsFillKind.gfkGradient;
        Orientation:= TTMSFMXGraphicsFillOrientation.gfoHorizontal;
      end;
    end;
    fPayment:= TfPayment.Create(self);
    fPayment.lytPayment.Parent:= pclForms.PageContainers[pclForms.Pages.Count- 1];
  end;}
end;

procedure TfWarehouseInTransit.tmrServerTimer(Sender: TObject);
var
  qrymessage: TUniquery;
begin
  CTime:= CTime + 0.0000115740740740741;
  lblDate.Text:= DateToStr(CDate + CTime);
  lblTime.Text:= TimeToStr(CDate + CTime);
  gtimeserver:= CDate + CTime;
  countmsg:= countmsg+ 1;
  if countmsg= 300 then begin
    qrymessage:= TUniquery.Create(self);
    try
      try
        with qrymessage do begin
          Connection:= conServer;
          Active:= False;
          SQL.Text:= 'SELECT Msg_ID, Berita FROM '+ gdatabase.Trim+
            '.ad_message WHERE Msg_ID= 1';
          Active:= True;
          lblMessage.Text:= FieldByName('Berita').AsString;
        end;
        if lblMessage.Text= '' then begin
          imgMessage.Visible:= False;
        end else begin
          imgMessage.Visible:= True;
        end;
      except
        on E: EDAError do begin
          if (E.ErrorCode= 1146) or (E.ErrorCode= 2003) or (E.ErrorCode= 1045) then begin
            lblMessage.Text:= '';
            countmsg:= 0;
          end;
        end;
      end;
    finally
      FreeAndNil(qrymessage);
      countmsg:= 0;
    end;
  end;
end;

procedure TfWarehouseInTransit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:= TCloseAction.caFree;
end;

procedure TfWarehouseInTransit.FormCreate(Sender: TObject);
begin
  WindowState:= TWindowState.wsMaximized;
  Position:= TFormPosition.DesktopCenter;
  with pclInTransit do begin
    ActivePageIndex:= 0;
    Interaction.CloseTabWithKeyboard:= False;
    Interaction.InsertTabWithKeyboard:= False;
    Interaction.SelectTabOnScroll:= False;
  end;
  pclInTransitHeight:= pclInTransit.Height;
  fanPclInTransit.StartValue:= pclInTransitHeight;
  fanPclInTransit.StopValue:= pclInTransitHeight;
  fanPclInTransit.Enabled:= True;
  with pclForms do begin
    Interaction.Reorder:= True;
    Interaction.CloseTabWithKeyboard:= False;
    Interaction.InsertTabWithKeyboard:= False;
    Interaction.SelectTabOnScroll:= False;
    Options.CloseMode:= TTMSFMXTabSetCloseMode.tcmTab;
    Options.CloseAction:= TTMSFMXTabSetTabCloseAction.ttcaFree;
    TabSize.Margins.Bottom:= 0;
    TabSize.Margins.Left:= 0;
    TabSize.Margins.Right:= 0;
    TabSize.Margins.Top:= 0;
  end;
  gdatabase:= '';
  gusername:= '';
  guserlocation:= '';
  countmsg:= 0;
  lblUsername.Text:= '';
  lblDate.Text:= '';
  lblTime.Text:= '';
  lblDatabase.Text:= '';
  lblServername.Text:= '';
  lblMessage.Text:= '';
  pclInTransit.Visible:= False;
  pclForms.Visible:= False;
  lytUsername.Visible:= False;
  lytDateTime.Visible:= False;
  lytDatabase.Visible:= False;
  lytServername.Visible:= False;
  imgMessage.Visible:= False;
  conServer:= TUniConnection.Create(nil);
  srmIcon:= TMemoryStream.Create;
  JumpFormCreate:= False;
  tmrServer:= TTimer.Create(self);
  tmrServer.Enabled:= False;
  tmrServer.OnTimer:= tmrServerTimer;
end;

procedure TfWarehouseInTransit.FormDestroy(Sender: TObject);
begin
  FreeAndNil(srmIcon);
  FreeAndNil(tmrServer);
  FreeAndNil(conServer);
  fWarehouseInTransit:= nil;
end;

procedure TfWarehouseInTransit.FormPaint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
begin
  mainformtop:= Top;
  mainformleft:= Left;
end;

procedure TfWarehouseInTransit.FormResize(Sender: TObject);
begin
  if Active= True then begin
    if ClientHeight< 500 then ClientHeight:= 500;
    if ClientWidth< 1024 then ClientWidth:= 1024;
  end;
end;

procedure TfWarehouseInTransit.FormShow(Sender: TObject);
begin
  btnCollapse.Images:= imlInTransit;
  btnCollapse.ImageIndex:= 1;
end;

procedure TfWarehouseInTransit.imgUsernameDblClick(Sender: TObject);
var
  i: integer;
begin
  i:= Screen.FormCount- 1;
  while i>= 0 do begin
    if Screen.Forms[i].Name<> 'fWarehouseInTransit' then begin
      showmessage(Screen.Forms[i].Name);
    end;
    dec(i);
  end;
end;

end.
