unit umyComboBox;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  System.StrUtils, FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.Edit, FMX.Layouts, FMX.StdCtrls,
  {Database}DBAccess, Data.DB, MemDS, Uni{Database}, FMX.TMSBaseControl,
  FMX.TMSGridCell, FMX.TMSGridOptions, FMX.TMSGridData, FMX.TMSCustomGrid,
  FMX.TMSGrid;

type
  TfmyComboBox = class(TForm)
    lytSearch: TLayout;
    edtSearch: TEdit;
    grdmyComboBox: TTMSFMXGrid;
    pnlFilter: TPanel;
    lytToolBar: TLayout;
    lytFilter: TLayout;
    edtFilter: TEdit;
    btnFind: TButton;
    lblRecord: TLabel;
    btnForward: TButton;
    lblPage: TLabel;
    btnRewind: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edtSearchTyping(Sender: TObject);
    procedure edtSearchEnter(Sender: TObject);
    procedure edtSearchKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure grdmyComboBoxCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure grdmyComboBoxKeyUp(Sender: TObject; var Key: Word;
      var KeyChar: Char; Shift: TShiftState);
    procedure btnFindClick(Sender: TObject);
    procedure edtFilterKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure btnRewindClick(Sender: TObject);
    procedure btnForwardClick(Sender: TObject);
    procedure grdmyComboBoxGetCellReadOnly(Sender: TObject; ACol, ARow: Integer;
      var AReadOnly: Boolean);
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
  private
    procedure Refresh;
    procedure LoadGrid;
    procedure CloseComboBox;
    procedure SetComboText;
    procedure FindData;
  public
  end;

var
  fmyComboBox: TfmyComboBox;

implementation

{$R *.fmx}

uses uWarehouseInTransit, uLogin;

var
  qryDropDown: TUniQuery;
  DropDownTop, DropDownLeft: integer;
  CloseMyForm, datarewind, dataforward: boolean;
  totalpages, startrow, totalrecord: int64;
  sqlku: string;

procedure TfmyComboBox.FindData;
var
  errorstrings: array of string;
  i: integer;
  myconcat: string;
begin
  errorstrings:= ['|', ''''];
  i:= 0;
  while i<= 1 do begin
    myconcat:= ReplaceStr(edtFilter.Text, errorstrings[i], '');
    inc(i);
  end;
  btnRewind.Enabled:= False;
  btnForward.Enabled:= True;
  dataforward:= True;
  datarewind:= False;
  lblPage.Text:= '1';
    with qryDropDown do begin
      if myForm= 'fLogin.edtDatabase' then begin
        Connection:= conInfo;
        Active:= False;
        SQL.Text:= 'SELECT COUNT(dbname) AS mypage FROM data_master '+
          'WHERE dbname LIKE ''%'+ myconcat.Trim+
          '%'' OR company LIKE ''%'+ myconcat.Trim+ '%'' ';
        Active:= True;
        if (FieldByName('mypage').AsLargeInt/ 100)< 1 then begin
          btnRewind.Enabled:= False;
          btnForward.Enabled:= False;
          dataforward:= False;
          datarewind:= False;
        end else if (FieldByName('mypage').AsLargeInt/ 100)>= 1 then begin
          if Frac(FieldByName('mypage').AsLargeInt/ 100)> 0 then begin
            totalpages:= Trunc(FieldByName('mypage').AsLargeInt/ 100)+ 1;
          end else if Frac(FieldByName('mypage').AsLargeInt/ 100)= 0 then begin
            totalpages:= Trunc(FieldByName('mypage').AsLargeInt/ 100);
          end;
          startrow:= 0;
        end;
        Active:= False;
        SQL.Text:= sqlku+ 'WHERE dbname LIKE ''%'+ myconcat.Trim+
          '%'' OR company LIKE ''%'+ myconcat.Trim+ '%'' '+
          'ORDER BY active DESC, dbname ASC LIMIT 100 OFFSET 0';
        Active:= True;
      end;

    end;
    LoadGrid;
    totalrecord:= qryDropDown.RecordCount;
    lblRecord.Text:= 'Rcds: '+ totalrecord.ToString;
end;

procedure TfmyComboBox.SetComboText;
var
  srmLogo: TMemoryStream;
begin
  if myForm= 'fLogin.edtDatabase' then begin
    qryDropDown.Locate('combotext',
      trim(grdmyComboBox.Cells[1, grdmyComboBox.Selected]), [loCaseInsensitive]);
    srmLogo:= TMemoryStream.Create;
    try
      with fLogin do begin
        qryInfoDatabase.Active:= False;
        qryInfoDatabase.SQL.Text:= 'SELECT dbname, myport, company, logo22, '+
          'logo75, icon FROM data_master WHERE dbname= '''+
          qryDropDown.FieldByName('combotext').AsString.Trim+'''';
        qryInfoDatabase.Active:= True;
        edtDatabase.Text:= qryDropDown.FieldByName('combotext').AsString.Trim;
        lblComp.Text:= qryDropDown.FieldByName('company').AsString.Trim;
        TBlobField(qryInfoDatabase.FieldByName('logo75')).SaveToStream(srmLogo);
        imgComp.Bitmap.LoadFromStream(srmLogo);
        qryInfoServer.Active:= False;
        qryInfoServer.SQL.Text:= 'SELECT serverkey, servername, serverip '+
          'FROM data_detail WHERE active=1 AND dbname= '''+
          qryInfoDatabase.FieldByName('dbname').AsString.Trim+'''';
        qryInfoServer.Active:= True;
      end;
    finally
      FreeAndNil(srmLogo);
    end;
    Close;
    fLogin.Activate;
  end;
end;

procedure TfmyComboBox.btnFindClick(Sender: TObject);
begin
  FindData;
end;

procedure TfmyComboBox.btnForwardClick(Sender: TObject);
var
  myconcat: string;
  errorstrings: array of string;
  i: integer;
begin
  errorstrings:= ['|', ''''];
  i:= 0;
  while i<= 1 do begin
    myconcat:= ReplaceStr(edtFilter.Text, errorstrings[i], '');
    inc(i);
  end;
    startrow:= startrow+ 100;
    with qryDropDown do begin
      if myForm= 'fLogin.edtDatabase' then begin
        Connection:= conInfo;
        Active:= False;
        SQL.Text:= sqlku+ 'WHERE dbname LIKE ''%'+ myconcat.Trim+
          '%'' OR company LIKE ''%'+ myconcat.Trim+ '%'' '+
          'ORDER BY active DESC, dbname ASC LIMIT 100 OFFSET '+
          startrow.ToString.Trim+ '';
        Active:= True;
      end;
    end;
    LoadGrid;
    totalrecord:= qryDropDown.RecordCount;
    lblRecord.Text:= 'Rcds: '+ totalrecord.ToString;
    lblPage.Text:= (lblPage.Text.Trim.ToInteger+ 1).ToString;
    if lblPage.Text.Trim.ToInteger<= 1 then begin
      btnRewind.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger> 1 then begin
      btnRewind.Enabled:= True;
    end;
    if totalpages= 0 then begin
      btnForward.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger= totalpages then begin
      btnForward.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger>= 1 then begin
      btnForward.Enabled:= True;
    end;
    dataforward:= True;
    datarewind:= False;
end;

procedure TfmyComboBox.btnRewindClick(Sender: TObject);
var
  myconcat: string;
  errorstrings: array of string;
  i: integer;
begin
  errorstrings:= ['|', ''''];
  i:= 0;
  while i<= 1 do begin
    myconcat:= ReplaceStr(edtFilter.Text, errorstrings[i], '');
    inc(i);
  end;
    startrow:= startrow- 100;
    with qryDropDown do begin
      if myForm= 'fLogin.edtDatabase' then begin
        Connection:= conInfo;
        Active:= False;
        SQL.Text:= sqlku+ 'WHERE dbname LIKE ''%'+ myconcat.Trim+
          '%'' OR company LIKE ''%'+ myconcat.Trim+ '%'' '+
          'ORDER BY active DESC, dbname ASC LIMIT 100 OFFSET '+
          startrow.ToString.Trim+ '';
        Active:= True;
      end;
    end;
    LoadGrid;
    totalrecord:= qryDropDown.RecordCount;
    lblRecord.Text:= 'Rcds: '+ totalrecord.ToString;
    lblPage.Text:= (lblPage.Text.Trim.ToInteger- 1).ToString;
    if lblPage.Text.Trim.ToInteger<= 1 then begin
      btnRewind.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger> 1 then begin
      btnRewind.Enabled:= True;
    end;
    if totalpages= 0 then begin
      btnForward.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger= totalpages then begin
      btnForward.Enabled:= False;
    end else if lblPage.Text.Trim.ToInteger>= 1 then begin
      btnForward.Enabled:= True;
    end;
    dataforward:= False;
    datarewind:= True;
end;

procedure TfmyComboBox.CloseComboBox;
begin
  Close;
  if (myForm= 'fLogin.edtDatabase') then begin
    fLogin.Activate;
  end;
end;

procedure TfmyComboBox.FormDeactivate(Sender: TObject);
begin
  if CloseMyForm= True then Close;
end;

procedure TfmyComboBox.FormDestroy(Sender: TObject);
begin
  FreeAndNil(qryDropDown);
  fmyComboBox:= nil;
end;

procedure TfmyComboBox.FormKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if Key= 27 then begin
    CloseComboBox;
  end;
end;

procedure TfmyComboBox.FormPaint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
begin
  CloseMyForm:= True;
end;

procedure TfmyComboBox.FormResize(Sender: TObject);
begin
  DropDownTop:= Top;
  DropDownLeft:= Left;
end;

procedure TfmyComboBox.FormShow(Sender: TObject);
begin
  if qryDropDown.RecordCount<= 0 then begin
    CloseComboBox;
  end else if qryDropDown.RecordCount> 0 then begin
    if (myForm= 'fLogin.edtDatabase') then begin
      if Screen.WorkAreaHeight< (DropDownTop+ Height) then begin
        pnlFilter.Align:= TAlignLayout.Top;
        lytSearch.Align:= TAlignLayout.Bottom;
        Top:= DropDownTop- round(Height)+
          trunc(edtSearch.Height);
      end;
      if Screen.WorkAreaWidth< round(DropDownLeft+ Width) then begin
        edtSearch.Align:= TAlignLayout.Right;
        Left:= DropDownLeft- round(Width)+
          trunc(edtSearch.Width);
      end;
    end;
    grdmyComboBox.SetFocus;
    edtSearch.SetFocus;
  end;
end;

procedure TfmyComboBox.grdmyComboBoxCellClick(Sender: TObject; ACol,
  ARow: Integer);
begin
  SetComboText;
end;

procedure TfmyComboBox.grdmyComboBoxGetCellReadOnly(Sender: TObject; ACol,
  ARow: Integer; var AReadOnly: Boolean);
begin
  if ARow> 0 then begin
    AReadOnly:= True;
  end;
end;

procedure TfmyComboBox.grdmyComboBoxKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (Key= 38) or (Key= 40) then begin
    if (myForm= 'fLogin.edtDatabase') then begin
      qryDropDown.Locate('combotext',
        trim(grdmyComboBox.Cells[1, grdmyComboBox.Selected]), [loCaseInsensitive]);
      edtSearch.Text:= qryDropDown.FieldByName('combotext').AsString.Trim;
    end;
  end;
  if Key= 13 then begin
    SetComboText;
  end;
  if Key= 27 then begin
    CloseComboBox;
  end;
end;

procedure TfmyComboBox.LoadGrid;
var
  i: integer;
begin
  with grdmyComboBox do begin
    BeginUpdate;
    Clear;
    with Options do begin
      with Keyboard do begin
        DeleteKeyHandling:= dkhNone;
        InsertKeyHandling:= ikhNone;
        //TabKeyDirectEdit:= True;// Untuk Editing
      end;
      Sorting.Mode:= gsmNormal;
      with Mouse do begin
        //DirectComboDrop:= True;// Untuk Editing
        //DirectEdit:= True;// Untuk Editing
        ColumnSizing:= True;
        RowSizing:= False;
        WheelScrollSize:= 1;
      end;
    end;
    SelectionMode:= smSingleRow;
    DefaultRowHeight:= 21;
    RowCount:= qryDropDown.RecordCount+ 1;
    ColumnCount:= qryDropDown.FieldCount+ 1;
    Cells[0, 0]:= '';
    Columns[0].Width:= 0;
    if myForm= 'fLogin.edtDatabase' then begin
      Cells[1, 0]:= 'Database';
      Cells[2, 0]:= 'Company';
      Columns[1].Width:= 80;
      Columns[2].Width:= 210;
    end;

    i:= 1;
    qryDropDown.First;
    while i<= qryDropDown.RecordCount do begin
      Cells[1, i]:= qryDropDown.FieldByName('combotext').AsString.Trim;
      if myForm= 'fLogin.edtDatabase' then begin
        Cells[2, i]:= qryDropDown.FieldByName('company').AsString.Trim;
      end;
     
      inc(i);
      qryDropDown.Next;
    end;
    EndUpdate;
  end;
end;

procedure TfmyComboBox.Refresh;
begin
  btnRewind.Enabled:= False;
  btnForward.Enabled:= True;
  dataforward:= True;
  datarewind:= False;
  lblPage.Text:= '1';
    with qryDropDown do begin
      if myForm= 'fLogin.edtDatabase' then begin
        Connection:= conInfo;
        Active:= False;
        SQL.Text:= 'SELECT COUNT(dbname) AS mypage FROM data_master';
        Active:= True;
        if (FieldByName('mypage').AsLargeInt/ 100)< 1 then begin
          btnRewind.Enabled:= False;
          btnForward.Enabled:= False;
          dataforward:= False;
          datarewind:= False;
        end else if (FieldByName('mypage').AsLargeInt/ 100)>= 1 then begin
          if Frac(FieldByName('mypage').AsLargeInt/ 100)> 0 then begin
            totalpages:= Trunc(FieldByName('mypage').AsLargeInt/ 100)+ 1;
          end else if Frac(FieldByName('mypage').AsLargeInt/ 100)= 0 then begin
            totalpages:= Trunc(FieldByName('mypage').AsLargeInt/ 100);
          end;
          startrow:= 0;
        end;
        Active:= False;
        SQL.Text:= sqlku+ 'ORDER BY active DESC, dbname ASC LIMIT 100 OFFSET 0';
        Active:= True;
        Width:= 310;
      end;

      if (RecordCount> 0) and (RecordCount<= 10) then begin
        pnlFilter.Visible:= False;
        Height:= 44+ round((RecordCount* 21)+ 0.5);
      end else if RecordCount> 10 then begin
        Height:= 44+ trunc(pnlFilter.Height)+ round((10* 21)+ 0.5);
      end;
    end;
    LoadGrid;
    totalrecord:= qryDropDown.RecordCount;
    lblRecord.Text:= 'Rcds: '+ totalrecord.ToString;
end;

procedure TfmyComboBox.edtFilterKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if Key= 13 then begin
    FindData;
  end;
end;

procedure TfmyComboBox.edtSearchEnter(Sender: TObject);
begin
  if (myForm= 'fLogin.edtDatabase') then begin
    grdmyComboBox.LookupInColumn(1, edtSearch.Text.Trim, False, True);
    qryDropDown.Locate('combotext', edtSearch.Text.Trim, [loCaseInsensitive,
      loPartialKey]);
  end;
end;

procedure TfmyComboBox.edtSearchKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if Key= 38 then begin
    grdmyComboBox.SetFocus;
    grdmyComboBox.Selected:= grdmyComboBox.Selected- 1;
    if (myForm= 'fLogin.edtDatabase') then begin
      qryDropDown.Locate('combotext',
        trim(grdmyComboBox.Cells[1, grdmyComboBox.Selected]), [loCaseInsensitive]);
      edtSearch.Text:= qryDropDown.FieldByName('combotext').AsString.Trim;
    end;
  end;
  if Key= 40 then begin
    grdmyComboBox.SetFocus;
    grdmyComboBox.Selected:= grdmyComboBox.Selected+ 1;
    if (myForm= 'fLogin.edtDatabase') then begin
      qryDropDown.Locate('combotext',
        trim(grdmyComboBox.Cells[1, grdmyComboBox.Selected]), [loCaseInsensitive]);
      edtSearch.Text:= qryDropDown.FieldByName('combotext').AsString.Trim;
    end;
  end;
  if Key= 13 then begin
    SetComboText;
  end;
  if Key= 27 then begin
    CloseComboBox;
  end;
end;

procedure TfmyComboBox.edtSearchTyping(Sender: TObject);
begin
  if (myForm= 'fLogin.edtDatabase') then begin
    grdmyComboBox.LookupInColumn(1, edtSearch.Text.Trim, False, True);
    qryDropDown.Locate('combotext', edtSearch.Text.Trim, [loCaseInsensitive,
      loPartialKey]);
  end;
end;

procedure TfmyComboBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= TCloseAction.caFree;
end;

procedure TfmyComboBox.FormCreate(Sender: TObject);
begin
  CloseMyForm:= False;
  Transparency:= True;
  qryDropDown:= TUniQuery.Create(self);
  if myForm= 'fLogin.edtDatabase' then begin
    sqlku:= 'SELECT dbname AS combotext, company FROM data_master ';
  end;
  Refresh;
end;

end.
